#' prettyDT
#'
#' @description DT base
#'
#' @param x x
#' @param ... else
#' @param l length
#' @param extensions_ extensions
#' @param drawCallback JS
#'
#' @return DT object
#'
#' @noRd
prettyDT <- function(
    x,
    l = 10,
    extensions_ = c("Buttons"),
    drawCallback = NULL,
    ...) {
  DT::datatable(
    x,
    # rownames = FALSE,
    class = "compact stripe row-border display nowrap",
    # escape = FALSE,
    escape=-1,
    options = list(
      pageLength = l,
      scrollX = TRUE,
      # autoWidth = TRUE,
      dom = "Bftip", #' Blfrtip',
      columnDefs = list(
        list( name = names(x),
          className = "dt-center",
          targets = "_all",
          # targets = 0,
          orderable = FALSE
        )
      ),
      drawCallback = drawCallback
    ),
    extensions = extensions_,
    # extensions = c("ColReorder","Buttons"),#,"Select"),
    # callback = JS(js),
    # selection = "multiple",
    # class = 'd-flex text-center',
    # filter = "top",
    ...
  )
}
