#' new_row Server Functions
#'
#' @noRd
mod_new_row_server <- function(id, what, reloadTrigger, project_update) {
  moduleServer(id, function(input, output, session) {
    ns <- session$ns


    fct_name <- paste("new", what, sep = "_")
    if (exists(fct_name)) {
      fct <- match.fun(fct_name)
      selector <- formals(fct) |> names()
      selector <- selector[selector != "id"]
    } else {
      print(paste("Function", fct_name, "not found!"))
    }
    # Filter selector to include only names that exist in correspondance_selector
    existing_selector <- selector[selector %in% names(correspondance_selector)]

    # Now use existing_selector to subset correspondance_selector
    widgets <- correspondance_selector[existing_selector]


    showModal(
      modalDialog(
        fluidRow(
          edit_input_form_2(
            default = list(),
            selector = widgets,
            var_mandatory = NULL,
            session = session
          )
        ),
        title = div(paste("Add new", what, sep = " "), class="modal-title"),
        size = "m",
        footer = list(
          # modalButton("Cancel"),
          tags$button(
            type = "button", class = "btn btn-default pull-left",
            `data-dismiss` = "modal", `data-bs-dismiss` = "modal",
            # validateIcon(icon),
            "Cancel"
          ),
          actionButton(
            ns("submit"),
            "Submit",
            class = "btn btn-primary btn-sm edit_btn",
            style = "color: white"
          )
        )
      )
    )


    observeEvent(input$submit, {
      # fct_name <- paste("new", what, sep = "_")
      args_list <- setNames(lapply(names(widgets), function(name) input[[name]]), names(widgets))
      args_list <- Filter(Negate(is.empty), args_list)

      do.call(fct, args_list)

      reloadTrigger(reloadTrigger() + 1) # Incrémente la valeur
      project_update(project_update() + 1)
      # Fermez le modal après la création du projet
      removeModal()
    })




    # reloadTrigger(reloadTrigger() + 1)
  })
}


setNames <- function (object = nm, nm) 
{
  names(object) <- nm
  object
}

